/********************************** (C) COPYRIGHT *******************************
* File Name          : CH563.C
* Author             : WCH
* Version            : V1.0
* Date               : 2013/11/15
* Description        : CH563 GPIOA_IO DEMO
*                      (1)CH563 Examples by KEIL;    
*                      (2)0Ϣ,115200bps;
*                      (3)ͨI/Oڲ,I/Oáá.
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include <stdio.h>
#include <string.h>
#include "CH563SFR.H"
#include "SYSFREQ.H"

/* һLEDڼʾĽ,͵ƽLED */
#define LED2                 1<<3
#define LED2_OUT_INIT(  )     { R32_PB_OUT |= LED2; R32_PB_DIR |= LED2; }         /* LED ߵƽΪ */
#define LED2_OUT_ACT(  )      { R32_PB_CLR |= LED2; }                            /* LED ͵ƽLEDʾ */
#define LED2_OUT_INACT(  )    { R32_PB_OUT |= LED2; }                            /* LED ߵƽرLEDʾ */


#define LED3                 1<<4
#define LED3_OUT_INIT(  )     { R32_PB_OUT |= LED3; R32_PB_DIR |= LED3; }         /* LED ߵƽΪ */
#define LED3_OUT_ACT(  )      { R32_PB_CLR |= LED3; }                            /* LED ͵ƽLEDʾ */
#define LED3_OUT_INACT(  )    { R32_PB_OUT |= LED3; }                            /* LED ߵƽرLEDʾ */

#define LED4                 1<<5
#define LED4_OUT_INIT(  )     { R32_PB_OUT |= LED4; R32_PB_DIR |= LED4; }         /* LED ߵƽΪ */
#define LED4_OUT_ACT(  )      { R32_PB_CLR |= LED4; }                            /* LED ͵ƽLEDʾ */
#define LED4_OUT_INACT(  )    { R32_PB_OUT |= LED4; }                            /* LED ߵƽرLEDʾ */

/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

__irq void IRQ_Handler( void )   
{
    while(1);
} 

/*******************************************************************************
* Function Name  : FIQ_Handler
* Description    : FIQжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

__irq void FIQ_Handler( void )
{
    while(1);
}

/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void mInitSTDIO( void )
{
    UINT32    x, x2;

    x = 10 * FREQ_SYS * 2 / 16 / 115200;                                        /* 115200bps */
    x2 = x % 10;
    x /= 10;
    if ( x2 >= 5 ) x ++;                                                        /*  */
    R8_UART0_LCR = 0x80;                                                        /* DLABλ1 */
    R8_UART0_DIV = 1;                                                           /* ԤƵ */
    R8_UART0_DLM = x>>8;
    R8_UART0_DLL = x&0xff;

    R8_UART0_LCR = RB_LCR_WORD_SZ ;                                             /* ֽڳΪ8 */
    R8_UART0_FCR = RB_FCR_FIFO_TRIG|RB_FCR_TX_FIFO_CLR|RB_FCR_RX_FIFO_CLR |    
                   RB_FCR_FIFO_EN ;                                             /* FIFOΪ14巢ͺͽFIFOFIFOʹ */
    R8_UART0_IER = RB_IER_TXD_EN;                                               /* TXD enable */
    R32_PB_SMT |= RXD0|TXD0;                                                    /* RXD0 schmitt input, TXD0 slow rate */
    R32_PB_PD &= ~ RXD0;                                                        /* disable pulldown for RXD0, keep pullup */
    R32_PB_DIR |= TXD0;                                                         /* TXD0 output enable */
}

/*******************************************************************************
* Function Name  : fputc
* Description    : ͨϢ
* Input          : c-- writes the character specified by c 
*                  *f--the output stream pointed to by *f
* Output         : None
* Return         : None
*******************************************************************************/

int fputc( int c, FILE *f )
{
    R8_UART0_THR = c;                                                           /*  */
    while( ( R8_UART0_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );                        /* ȴݷ */
    return( c );
}

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

int main( void )
{
    LED2_OUT_INIT( );
	LED3_OUT_INIT( );
	LED4_OUT_INIT( );

    LED2_OUT_ACT( );                                                             /* LEDһʾ */
    Delay_ms(100);                                                              
    LED2_OUT_INACT( );
    mInitSTDIO( );                                                              /* 0ʼ */
    PRINT("GPIOA DEMO....\n");                                                  /* س */
    while(1){
       
        LED2_OUT_ACT( );  
		Delay_ms(300);

        LED2_OUT_INACT( );
		LED3_OUT_ACT( ); 
		Delay_ms(300);

		LED3_OUT_INACT( );
		LED4_OUT_ACT( );  
		Delay_ms(300);

        LED4_OUT_INACT( );

    }    
}

/*********************************** endfile **********************************/
